package com.uncc.tv;

import java.io.IOException;

import com.lhy.tool.util.Utils;
import com.uncc.tv.recommender.GPMF;
import com.uncc.tv.recommender.WGPMF;

public class Main {

	public static void main(String[] args) throws IOException, TVException {
		ParamManager param = TVConstants.initConfig();
		String modelName   = param.getModelName().toLowerCase();
		if ("gpmf".equals(modelName)) {
			Utils.println("[Info] Start GPMF...");
			new GPMF(param).estimate();
		} else
		if ("wgpmf".equals(modelName)) {
			Utils.println("[Info] Start WGPMF...");
			new WGPMF(param).estimate();
		}
	}
}
