package com.uncc.tv;

import java.io.File;
import java.text.SimpleDateFormat;

import com.lhy.tool.util.Utils;

/**
 * This is class is not cleaned. Most of constants are used in some other
 * methods which are not open.
 * 
 * @author Huayu Li
 *
 */
public class TVConstants {
	private static final String FILE_NAME_TV_PROGRAM   = "mPMF";
	private static final String FILE_NAME_OUTPUT       = "output";
	private static final File PATH_CURRENT_RUNNING     =
			new File(System.getProperty("user.dir"));
	public static final File PATH_OUTPUT               = 
			new File((PATH_CURRENT_RUNNING.getParentFile().exists() ?
				new File(PATH_CURRENT_RUNNING.getParentFile(), FILE_NAME_OUTPUT) :
				new File(PATH_CURRENT_RUNNING, FILE_NAME_OUTPUT)),
				FILE_NAME_TV_PROGRAM);
	public static final File PATH_DATA                     =
			new File(PATH_OUTPUT, "data");
	public static final File PATH_CLUSTERING               =
			new File(PATH_OUTPUT, "clustering");
	public static final File PATH_SELECTED_RAW             =
			new File(PATH_DATA, "selected_raw");
	public static final File PATH_VALID_RAW                =
			new File(PATH_DATA, "valid_raw");
	public static final File PATH_SCHEDULE                 =
			new File(PATH_DATA, "schedule");
	public static final File PATH_RATING                   =
			new File(PATH_DATA, "rating");
	public static final File PATH_RATING_PERCENTAGE        =
			new File(PATH_RATING, "percentage");
	public static final File PATH_RATING_BINARY            =
			new File(PATH_RATING, "binary");
	public static final File PATH_RATING_TIMES             =
			new File(PATH_RATING, "times");
	public static final File PATH_RATING_WEIGHTED_PERCENTAGE =
			new File(PATH_RATING, "weighted_percentage");
	public static final File PATH_CLUSTERING_GRAPH         =
			new File(PATH_CLUSTERING, "graph");
	public static final File PATH_CLUSTERING_OUTPUT        =
			new File(PATH_CLUSTERING, "output");
	public static final File PATH_MODEL                    =
			new File(PATH_OUTPUT, "model");

	public static final File FILE_SCHEDULE_VALID_PROGRAM_IDS =
			new File(PATH_SCHEDULE, "Valid_Program_Ids");
	public static final File FILE_SCHEDULE_INVALID_USER_IDS =
			new File(PATH_SCHEDULE, "Invalid_User_Ids");
	public static final File FILE_SELECTED_USER_IDS        =
			new File(PATH_DATA, "Selected_User_Ids");
	public static final File FILE_USER_REC_TOTAL           =
			new File(PATH_DATA, "User_Rec_Total");
	public static final File FILE_USER_REC_TRAIN           =
			new File(PATH_DATA, "User_Rec_Train");
	public static final File FILE_USER_REC_TEST            =
			new File(PATH_DATA, "User_Rec_Test");
	public static final File FILE_USER_REC_ENCODED_TRAIN   =
			new File(PATH_DATA, "User_Rec_User_Cluster_Encoded_Train");
	public static final File FILE_USER_REC_ENCODED_TEST    =
			new File(PATH_DATA, "User_Rec_User_Cluster_Encoded_Test");
	public static final File FILE_USER_REC_STATS_TOTAL     =
			new File(PATH_DATA, "User_Rec_Total_Stat");
	public static final File FILE_USER_DICTIONARY          =
			new File(PATH_DATA, "User_Dictionary");
	public static final File FILE_PROGRAM_DICTIONARY       =
			new File(PATH_DATA, "Program_Dictionary");
	public static final File FILE_SUB_GENRE_DICTIONARY     =
			new File(PATH_DATA, "Sub_Genre_Dictionary");
	public static final File FILE_FIRST_LEVEL_GENRE_DICTIONARY = 
			new File(PATH_DATA, "First_Level_Genre_Dictionary");
	public static final File FILE_STATS_PROGRAM_GENRE      =
			new File(PATH_DATA, "Program_Genre_Stat");
	public static final File FILE_PROGRAM_GENRE_MAP        =
			new File(PATH_DATA, "Program_Genre_Map");
	public static final File FILE_USER_REC_PROGRAM_CLUSTER_ENCODED_TRAIN =
			new File(PATH_DATA, "User_Rec_Program_Cluster_Encoded_train");
	public static final File FILE_USER_REC_SORTED_TRAIN_FOR_CLUSTER_PROGRAM =
			new File(PATH_DATA, "User_Rec_Sorted_Train_For_Cluster_Program");
	public static final File FILE_USER_REC_SORTED_TRAIN_FOR_CLUSTER_PROGRAM_INSTANCE_NUM =
			new File(PATH_DATA, "User_Rec_Sorted_Train_For_Cluster_Program_Instance_Num");

	// ratings in terms of percentage
	public static final File FILE_USER_REC_PERCENTAGE_TOTAL_RAW_VALUE =
			new File(PATH_RATING_PERCENTAGE, "User_Rec_Total_Raw_Value");
	public static final File FILE_USER_REC_PERCENTAGE_TRAIN_RAW_VALUE =
			new File(PATH_RATING_PERCENTAGE, "User_Rec_Train_Raw_Value");
	public static final File FILE_USER_REC_PERCENTAGE_TEST_RAW_VALUE =
			new File(PATH_RATING_PERCENTAGE, "User_Rec_Test_Raw_Value");
	public static final File FILE_USER_REC_PERCENTAGE_STATS_TRAIN    =
			new File(PATH_RATING_PERCENTAGE, "User_Rec_Percentage_Train_Stat");
	public static final File FILE_USER_REC_PERCENTAGE_STATS_TEST     =
			new File(PATH_RATING_PERCENTAGE, "User_Rec_Percentage_Test_Stat");
	// ratings in terms of binary
	public static final File FILE_USER_REC_BINARY_TRAIN_RATING =
			new File(PATH_RATING_BINARY, "User_Rec_Binary_Rating_Train");
	public static final File FILE_USER_REC_BINARY_TEST_RATING  =
			new File(PATH_RATING_BINARY, "User_Rec_Binary_Rating_Test");
	public static final File FILE_USER_REC_BINARY_STATS_TRAIN  =
			new File(PATH_RATING_BINARY, "User_Rec_Binary_Train_Stat");
	public static final File FILE_USER_REC_BINARY_STATS_TEST   =
			new File(PATH_RATING_BINARY, "User_Rec_Binary_Test_Stat");
	// ratings in terms of times
	public static final File FILE_USER_REC_TIMES_RATING_TOTAL =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Rating_Total");
	public static final File FILE_USER_REC_TIMES_RATING_TRAIN =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Rating_Train");
	public static final File FILE_USER_REC_TIMES_RATING_TEST  =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Rating_Test");
	public static final File FILE_USER_REC_TIMES_STATS_TOTAL  =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Total_Stat");
	public static final File FILE_USER_REC_TIMES_STATS_TRAIN  =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Train_Stat");
	public static final File FILE_USER_REC_TIMES_STATS_TEST   =
			new File(PATH_RATING_TIMES, "User_Rec_Times_Test_Stat");
	// ratings in terms of weighted percentage and tiems
	public static final File FILE_USER_REC_WEIGHT_PERCENTAGE_TRAIN =
			new File(PATH_RATING_WEIGHTED_PERCENTAGE, "User_Rec_Weighted_Percentage_Train");
	public static final File FILE_USER_REC_WEIGHT_PERCENTAGE_TEST =
			new File(PATH_RATING_WEIGHTED_PERCENTAGE, "User_Rec_Weighted_Percentage_Test");

	public static final File FILE_TRAIN_USER_CLUSTERING_LABEL    =
			new File(PATH_CLUSTERING, "Train_User_Clustering_Label");
	public static final File FILE_TRAIN_USER_CLUSTERING_CENTROID =
			new File(PATH_CLUSTERING, "Train_User_Clustering_Centroid");
	public static final File FILE_TRAIN_USER_CLUSTERING_COUNT    =
			new File(PATH_CLUSTERING, "Train_User_Clustring_Count");
	public static final File FILE_TRAIN_USER_REC_CLUSTER_LABEL   =
			new File(PATH_CLUSTERING, "Train_User_Rec_Cluster_Label");
	public static final File FILE_TRAIN_CLUSTER_FILE =
			new File(PATH_CLUSTERING, "Train_Cluster_File");

	public static final SimpleDateFormat USER_REC_START_TIME_FORMAT   =
			new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
	public static final SimpleDateFormat USER_REC_COMPARE_TIME_FORMAT =
			new SimpleDateFormat("MMddHHmm");

	public static final String SPACER = "\t";

	public static final String COLUMN_NUM_NOT_MATCH =
			"Column num does not match.[PredefinedColumnNum=%s][ParsedColumnNum=%s]";

	public static final int TOTAL_COLUMN_NUM_GENRE       = 4;
	public static final int TOTAL_COLUMN_NUM_SCHEDULE    = 20;
	public static final int TOTLA_COLUMN_NUM_TITLE       = 8;
	public static final int TOTAL_COLUMN_NUM_USER_REC    = 5;
	public static final int TOTAL_COLUMN_NUM_USER_REC_ADD_SCH_DURATION =
			TOTAL_COLUMN_NUM_USER_REC + 1;
	public static final int INDEX_GENRE_PROGRAM_ID       = 1;
	public static final int INDEX_GENRE_SUB_GENRE        = 2;
	public static final int INDEX_GENRE_FIRST_LEVEL      = 3;
	public static final int INDEX_SCHEDULE_CHANNEL       = 1;
	public static final int INDEX_SCHEDULE_START_TIME    = 2;
	public static final int INDEX_SCHEDULE_END_TIME      =
					INDEX_SCHEDULE_START_TIME + 1;
	public static final int INDEX_SCHEDULE_SPECIFIC_PROGRAM_ID = 4;
	public static final int INDEX_SCHEDULE_DURATION            = 6;
	public static final int INDEX_TITLE_PROGRAM_ID             = 1;
	public static final int INDEX_TITLE_LOCALE                 = 2;
	public static final int INDEX_USER_REC_USER_ID             = 0;
	public static final int INDEX_USER_REC_PROGRAM_ID          = 1;
	public static final int INDEX_USER_REC_START_TIME          = 2;
	public static final int INDEX_USER_REC_CHANNEL             = 3;
	public static final int INDEX_USER_REC_DURATION            = 4;
	public static final int INDEX_USER_REC_SCHEDULE_DURATION   = 5;

	public static final String STRING_OUTPUT_PATH        = "OutputPath";
	public static final String STRING_TRAIN_RATING_FILE  = "TrainRatingFile";
	public static final String STRING_TRAIN_CLUSER_FILE  = "TrainClusterFile";
	public static final String STRING_TEST_FILE          = "TestFile";
	public static final String STRING_TEL_FEA_INIT_FILE  = "TelevisionFeatureInitFile";
	public static final String STRING_PROG_FEA_INIT_FILE = "ProgramFeatureInitFile";
	public static final String STRING_MODEL              = "Model";
	public static final String STRING_FEATURE_NUM        = "FeatureNum";
	public static final String STRING_GROUP_NUM          = "GroupNum";
	public static final String STRING_TELEVISION_NUM     = "TelevisionNum";
	public static final String STRING_PROGRAM_NUM        = "ProgramNum";
	public static final String STRING_CONVERGE_THRESHOLD = "ConvergeThreshold";

	private static final String FILE_NAME_CONFIG = "Configure";
	private static File FILE_CONFIG           = null;
	
	public static ParamManager initConfig() {
		ParamManager CONFIG_MANAGER = null;
		String sprop = System.getProperty("PATH_CONFIGURE");
		if (! Utils.isEmpty(sprop)) {
			FILE_CONFIG = new File(new File(sprop), FILE_NAME_CONFIG);
		} else {
			FILE_CONFIG = new File(PATH_CURRENT_RUNNING, FILE_NAME_CONFIG);
		}

		if (! FILE_CONFIG.exists()) {
			CONFIG_MANAGER = new ParamManager();

			CONFIG_MANAGER.setFeatureNum(10);
			CONFIG_MANAGER.setOutputPath(PATH_MODEL);

			if (! CONFIG_MANAGER.store(FILE_CONFIG)) {
				Utils.err("Failed to store configure file.");
			}
		} else {
			CONFIG_MANAGER = new ParamManager();
			try {
				CONFIG_MANAGER.load(FILE_CONFIG);
			} catch (TVException e) {
				e.printStackTrace();
				System.exit(-1);
			}
		}

		// override some properties
		try {
			sprop = System.getProperty("FEATURE_NUM");
			if (sprop != null) {
				CONFIG_MANAGER.setFeatureNum(Integer.parseInt(sprop));
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
			System.exit(-1);
		}

		Utils.println("================== Configure ==================");
		Utils.println(CONFIG_MANAGER);
		Utils.println("===============================================");
		return CONFIG_MANAGER;
	}
}
